package alphavantage

import (
	"testing"
)

func TestCurrencyCode_String(t *testing.T) {
	tests := []struct {
		code CurrencyCode
		want string
	}{
		{
			code: CurrencyCodeEUR,
			want: "EUR",
		},
		{
			code: CurrencyCodeUSD,
			want: "USD",
		},
	}
	for _, tt := range tests {
		t.Run(tt.want, func(t *testing.T) {
			if got := tt.code.String(); got != tt.want {
				t.Errorf("CurrencyCode.String() = %v, want %v", got, tt.want)
			}
		})
	}
}

func TestCurrencyCode_IsPhysical(t *testing.T) {
	tests := []struct {
		c    CurrencyCode
		want bool
	}{
		{CurrencyCodeAED, true},
		{CurrencyCodeAFN, true},
		{CurrencyCodeALL, true},
		{CurrencyCodeAMD, true},
		{CurrencyCodeANG, true},
		{CurrencyCodeAOA, true},
		{CurrencyCodeARS, true},
		{CurrencyCodeAUD, true},
		{CurrencyCodeAWG, true},
		{CurrencyCodeAZN, true},
		{CurrencyCodeBAM, true},
		{CurrencyCodeBBD, true},
		{CurrencyCodeBDT, true},
		{CurrencyCodeBGN, true},
		{CurrencyCodeBHD, true},
		{CurrencyCodeBIF, true},
		{CurrencyCodeBMD, true},
		{CurrencyCodeBND, true},
		{CurrencyCodeBOB, true},
		{CurrencyCodeBRL, true},
		{CurrencyCodeBSD, true},
		{CurrencyCodeBTN, true},
		{CurrencyCodeBWP, true},
		{CurrencyCodeBZD, true},
		{CurrencyCodeCAD, true},
		{CurrencyCodeCDF, true},
		{CurrencyCodeCHF, true},
		{CurrencyCodeCLF, true},
		{CurrencyCodeCLP, true},
		{CurrencyCodeCNH, true},
		{CurrencyCodeCNY, true},
		{CurrencyCodeCOP, true},
		{CurrencyCodeCUP, true},
		{CurrencyCodeCVE, true},
		{CurrencyCodeCZK, true},
		{CurrencyCodeDJF, true},
		{CurrencyCodeDKK, true},
		{CurrencyCodeDOP, true},
		{CurrencyCodeDZD, true},
		{CurrencyCodeEGP, true},
		{CurrencyCodeERN, true},
		{CurrencyCodeETB, true},
		{CurrencyCodeEUR, true},
		{CurrencyCodeFJD, true},
		{CurrencyCodeFKP, true},
		{CurrencyCodeGBP, true},
		{CurrencyCodeGEL, true},
		{CurrencyCodeGHS, true},
		{CurrencyCodeGIP, true},
		{CurrencyCodeGMD, true},
		{CurrencyCodeGNF, true},
		{CurrencyCodeGTQ, true},
		{CurrencyCodeGYD, true},
		{CurrencyCodeHKD, true},
		{CurrencyCodeHNL, true},
		{CurrencyCodeHRK, true},
		{CurrencyCodeHTG, true},
		{CurrencyCodeHUF, true},
		{CurrencyCodeIDR, true},
		{CurrencyCodeILS, true},
		{CurrencyCodeINR, true},
		{CurrencyCodeIQD, true},
		{CurrencyCodeIRR, true},
		{CurrencyCodeISK, true},
		{CurrencyCodeJEP, true},
		{CurrencyCodeJMD, true},
		{CurrencyCodeJOD, true},
		{CurrencyCodeJPY, true},
		{CurrencyCodeKES, true},
		{CurrencyCodeKGS, true},
		{CurrencyCodeKHR, true},
		{CurrencyCodeKMF, true},
		{CurrencyCodeKPW, true},
		{CurrencyCodeKRW, true},
		{CurrencyCodeKWD, true},
		{CurrencyCodeKYD, true},
		{CurrencyCodeKZT, true},
		{CurrencyCodeLAK, true},
		{CurrencyCodeLBP, true},
		{CurrencyCodeLKR, true},
		{CurrencyCodeLRD, true},
		{CurrencyCodeLSL, true},
		{CurrencyCodeLYD, true},
		{CurrencyCodeMAD, true},
		{CurrencyCodeMDL, true},
		{CurrencyCodeMGA, true},
		{CurrencyCodeMKD, true},
		{CurrencyCodeMMK, true},
		{CurrencyCodeMNT, true},
		{CurrencyCodeMOP, true},
		{CurrencyCodeMRO, true},
		{CurrencyCodeMRU, true},
		{CurrencyCodeMUR, true},
		{CurrencyCodeMVR, true},
		{CurrencyCodeMWK, true},
		{CurrencyCodeMXN, true},
		{CurrencyCodeMYR, true},
		{CurrencyCodeMZN, true},
		{CurrencyCodeNAD, true},
		{CurrencyCodeNGN, true},
		{CurrencyCodeNOK, true},
		{CurrencyCodeNPR, true},
		{CurrencyCodeNZD, true},
		{CurrencyCodeOMR, true},
		{CurrencyCodePAB, true},
		{CurrencyCodePEN, true},
		{CurrencyCodePGK, true},
		{CurrencyCodePHP, true},
		{CurrencyCodePKR, true},
		{CurrencyCodePLN, true},
		{CurrencyCodePYG, true},
		{CurrencyCodeQAR, true},
		{CurrencyCodeRON, true},
		{CurrencyCodeRSD, true},
		{CurrencyCodeRUB, true},
		{CurrencyCodeRUR, true},
		{CurrencyCodeRWF, true},
		{CurrencyCodeSAR, true},
		{CurrencyCodeSBD, true},
		{CurrencyCodeSCR, true},
		{CurrencyCodeSDG, true},
		{CurrencyCodeSEK, true},
		{CurrencyCodeSGD, true},
		{CurrencyCodeSHP, true},
		{CurrencyCodeSLL, true},
		{CurrencyCodeSOS, true},
		{CurrencyCodeSRD, true},
		{CurrencyCodeSYP, true},
		{CurrencyCodeSZL, true},
		{CurrencyCodeTHB, true},
		{CurrencyCodeTJS, true},
		{CurrencyCodeTMT, true},
		{CurrencyCodeTND, true},
		{CurrencyCodeTOP, true},
		{CurrencyCodeTRY, true},
		{CurrencyCodeTTD, true},
		{CurrencyCodeTWD, true},
		{CurrencyCodeTZS, true},
		{CurrencyCodeUAH, true},
		{CurrencyCodeUGX, true},
		{CurrencyCodeUSD, true},
		{CurrencyCodeUYU, true},
		{CurrencyCodeUZS, true},
		{CurrencyCodeVND, true},
		{CurrencyCodeVUV, true},
		{CurrencyCodeWST, true},
		{CurrencyCodeXAF, true},
		{CurrencyCodeXAG, true},
		{CurrencyCodeXAU, true},
		{CurrencyCodeXCD, true},
		{CurrencyCodeXDR, true},
		{CurrencyCodeXOF, true},
		{CurrencyCodeXPF, true},
		{CurrencyCodeYER, true},
		{CurrencyCodeZAR, true},
		{CurrencyCodeZMW, true},
		{CurrencyCodeZWL, true},
		{CurrencyCode1ST, false},
		{CurrencyCode2GIVE, false},
		{CurrencyCode808, false},
		{CurrencyCodeABT, false},
		{CurrencyCodeABY, false},
		{CurrencyCodeAC, false},
		{CurrencyCodeACT, false},
		{CurrencyCodeADA, false},
		{CurrencyCodeADT, false},
		{CurrencyCodeADX, false},
		{CurrencyCodeAE, false},
		{CurrencyCodeAEON, false},
		{CurrencyCodeAGI, false},
		{CurrencyCodeAGRS, false},
		{CurrencyCodeAI, false},
		{CurrencyCodeAID, false},
		{CurrencyCodeAION, false},
		{CurrencyCodeAIR, false},
		{CurrencyCodeAKY, false},
		{CurrencyCodeALIS, false},
		{CurrencyCodeAMBER, false},
		{CurrencyCodeAMP, false},
		{CurrencyCodeAMPL, false},
		{CurrencyCodeANC, false},
		{CurrencyCodeANT, false},
		{CurrencyCodeAPPC, false},
		{CurrencyCodeAPX, false},
		{CurrencyCodeARDR, false},
		{CurrencyCodeARK, false},
		{CurrencyCodeARN, false},
		{CurrencyCodeAST, false},
		{CurrencyCodeATB, false},
		{CurrencyCodeATM, false},
		{CurrencyCodeATS, false},
		{CurrencyCodeAUR, false},
		{CurrencyCodeAVT, false},
		{CurrencyCodeB3, false},
		{CurrencyCodeBAT, false},
		{CurrencyCodeBAY, false},
		{CurrencyCodeBBR, false},
		{CurrencyCodeBCAP, false},
		{CurrencyCodeBCC, false},
		{CurrencyCodeBCD, false},
		{CurrencyCodeBCH, false},
		{CurrencyCodeBCN, false},
		{CurrencyCodeBCPT, false},
		{CurrencyCodeBCX, false},
		{CurrencyCodeBCY, false},
		{CurrencyCodeBDL, false},
		{CurrencyCodeBEE, false},
		{CurrencyCodeBELA, false},
		{CurrencyCodeBET, false},
		{CurrencyCodeBFT, false},
		{CurrencyCodeBIS, false},
		{CurrencyCodeBITB, false},
		{CurrencyCodeBITBTC, false},
		{CurrencyCodeBITCNY, false},
		{CurrencyCodeBITEUR, false},
		{CurrencyCodeBITGOLD, false},
		{CurrencyCodeBITSILVER, false},
		{CurrencyCodeBITUSD, false},
		{CurrencyCodeBIX, false},
		{CurrencyCodeBLITZ, false},
		{CurrencyCodeBLK, false},
		{CurrencyCodeBLN, false},
		{CurrencyCodeBLOCK, false},
		{CurrencyCodeBLZ, false},
		{CurrencyCodeBMC, false},
		{CurrencyCodeBNB, false},
		{CurrencyCodeBNT, false},
		{CurrencyCodeBNTY, false},
		{CurrencyCodeBOST, false},
		{CurrencyCodeBOT, false},
		{CurrencyCodeBQ, false},
		{CurrencyCodeBRD, false},
		{CurrencyCodeBRK, false},
		{CurrencyCodeBRX, false},
		{CurrencyCodeBTA, false},
		{CurrencyCodeBTC, false},
		{CurrencyCodeBTCD, false},
		{CurrencyCodeBTCP, false},
		{CurrencyCodeBTG, false},
		{CurrencyCodeBTM, false},
		{CurrencyCodeBTS, false},
		{CurrencyCodeBTSR, false},
		{CurrencyCodeBTX, false},
		{CurrencyCodeBURST, false},
		{CurrencyCodeBUSD, false},
		{CurrencyCodeBUZZ, false},
		{CurrencyCodeBYC, false},
		{CurrencyCodeBYTOM, false},
		{CurrencyCodeC20, false},
		{CurrencyCodeCANN, false},
		{CurrencyCodeCAT, false},
		{CurrencyCodeCCRB, false},
		{CurrencyCodeCDT, false},
		{CurrencyCodeCFI, false},
		{CurrencyCodeCHAT, false},
		{CurrencyCodeCHIPS, false},
		{CurrencyCodeCLAM, false},
		{CurrencyCodeCLOAK, false},
		{CurrencyCodeCMP, false},
		{CurrencyCodeCMT, false},
		{CurrencyCodeCND, false},
		{CurrencyCodeCNX, false},
		{CurrencyCodeCOFI, false},
		{CurrencyCodeCOSS, false},
		{CurrencyCodeCOVAL, false},
		{CurrencyCodeCRBIT, false},
		{CurrencyCodeCREA, false},
		{CurrencyCodeCREDO, false},
		{CurrencyCodeCRW, false},
		{CurrencyCodeCSNO, false},
		{CurrencyCodeCTR, false},
		{CurrencyCodeCTXC, false},
		{CurrencyCodeCURE, false},
		{CurrencyCodeCVC, false},
		{CurrencyCodeDAI, false},
		{CurrencyCodeDAR, false},
		{CurrencyCodeDASH, false},
		{CurrencyCodeDATA, false},
		{CurrencyCodeDAY, false},
		{CurrencyCodeDBC, false},
		{CurrencyCodeDBIX, false},
		{CurrencyCodeDCN, false},
		{CurrencyCodeDCR, false},
		{CurrencyCodeDCT, false},
		{CurrencyCodeDDF, false},
		{CurrencyCodeDENT, false},
		{CurrencyCodeDFS, false},
		{CurrencyCodeDGB, false},
		{CurrencyCodeDGC, false},
		{CurrencyCodeDGD, false},
		{CurrencyCodeDICE, false},
		{CurrencyCodeDLT, false},
		{CurrencyCodeDMD, false},
		{CurrencyCodeDMT, false},
		{CurrencyCodeDNT, false},
		{CurrencyCodeDOGE, false},
		{CurrencyCodeDOPE, false},
		{CurrencyCodeDRGN, false},
		{CurrencyCodeDTA, false},
		{CurrencyCodeDTB, false},
		{CurrencyCodeDYN, false},
		{CurrencyCodeEAC, false},
		{CurrencyCodeEBST, false},
		{CurrencyCodeEBTC, false},
		{CurrencyCodeECC, false},
		{CurrencyCodeECN, false},
		{CurrencyCodeEDG, false},
		{CurrencyCodeEDO, false},
		{CurrencyCodeEFL, false},
		{CurrencyCodeEGC, false},
		{CurrencyCodeEKT, false},
		{CurrencyCodeELA, false},
		{CurrencyCodeELEC, false},
		{CurrencyCodeELF, false},
		{CurrencyCodeELIX, false},
		{CurrencyCodeEMB, false},
		{CurrencyCodeEMC, false},
		{CurrencyCodeEMC2, false},
		{CurrencyCodeENG, false},
		{CurrencyCodeENJ, false},
		{CurrencyCodeENRG, false},
		{CurrencyCodeEOS, false},
		{CurrencyCodeEOT, false},
		{CurrencyCodeEQT, false},
		{CurrencyCodeERC, false},
		{CurrencyCodeETC, false},
		{CurrencyCodeETH, false},
		{CurrencyCodeETHD, false},
		{CurrencyCodeETHOS, false},
		{CurrencyCodeETN, false},
		{CurrencyCodeETP, false},
		{CurrencyCodeETT, false},
		{CurrencyCodeEVE, false},
		{CurrencyCodeEVX, false},
		{CurrencyCodeEXCL, false},
		{CurrencyCodeEXP, false},
		{CurrencyCodeFCT, false},
		{CurrencyCodeFLDC, false},
		{CurrencyCodeFLO, false},
		{CurrencyCodeFLT, false},
		{CurrencyCodeFRST, false},
		{CurrencyCodeFTC, false},
		{CurrencyCodeFUEL, false},
		{CurrencyCodeFUN, false},
		{CurrencyCodeGAM, false},
		{CurrencyCodeGAME, false},
		{CurrencyCodeGAS, false},
		{CurrencyCodeGBG, false},
		{CurrencyCodeGBX, false},
		{CurrencyCodeGBYTE, false},
		{CurrencyCodeGCR, false},
		{CurrencyCodeGEO, false},
		{CurrencyCodeGLD, false},
		{CurrencyCodeGNO, false},
		{CurrencyCodeGNT, false},
		{CurrencyCodeGOLOS, false},
		{CurrencyCodeGRC, false},
		{CurrencyCodeGRS, false},
		{CurrencyCodeGRWI, false},
		{CurrencyCodeGTC, false},
		{CurrencyCodeGTO, false},
		{CurrencyCodeGUP, false},
		{CurrencyCodeGVT, false},
		{CurrencyCodeGXS, false},
		{CurrencyCodeHBN, false},
		{CurrencyCodeHEAT, false},
		{CurrencyCodeHMQ, false},
		{CurrencyCodeHPB, false},
		{CurrencyCodeHSR, false},
		{CurrencyCodeHUSH, false},
		{CurrencyCodeHVN, false},
		{CurrencyCodeHXX, false},
		{CurrencyCodeICN, false},
		{CurrencyCodeICX, false},
		{CurrencyCodeIFC, false},
		{CurrencyCodeIFT, false},
		{CurrencyCodeIGNIS, false},
		{CurrencyCodeINCNT, false},
		{CurrencyCodeIND, false},
		{CurrencyCodeINF, false},
		{CurrencyCodeINK, false},
		{CurrencyCodeINS, false},
		{CurrencyCodeINSTAR, false},
		{CurrencyCodeINT, false},
		{CurrencyCodeINXT, false},
		{CurrencyCodeIOC, false},
		{CurrencyCodeION, false},
		{CurrencyCodeIOP, false},
		{CurrencyCodeIOST, false},
		{CurrencyCodeIOTA, false},
		{CurrencyCodeIOTX, false},
		{CurrencyCodeIQT, false},
		{CurrencyCodeITC, false},
		{CurrencyCodeIXC, false},
		{CurrencyCodeIXT, false},
		{CurrencyCodeJ8T, false},
		{CurrencyCodeJNT, false},
		{CurrencyCodeKCS, false},
		{CurrencyCodeKICK, false},
		{CurrencyCodeKIN, false},
		{CurrencyCodeKMD, false},
		{CurrencyCodeKNC, false},
		{CurrencyCodeKORE, false},
		{CurrencyCodeLBC, false},
		{CurrencyCodeLCC, false},
		{CurrencyCodeLEND, false},
		{CurrencyCodeLEV, false},
		{CurrencyCodeLGD, false},
		{CurrencyCodeLINDA, false},
		{CurrencyCodeLINK, false},
		{CurrencyCodeLKK, false},
		{CurrencyCodeLMC, false},
		{CurrencyCodeLOCI, false},
		{CurrencyCodeLOOM, false},
		{CurrencyCodeLRC, false},
		{CurrencyCodeLSK, false},
		{CurrencyCodeLTC, false},
		{CurrencyCodeLUN, false},
		{CurrencyCodeMAID, false},
		{CurrencyCodeMANA, false},
		{CurrencyCodeMAX, false},
		{CurrencyCodeMBRS, false},
		{CurrencyCodeMCAP, false},
		{CurrencyCodeMCO, false},
		{CurrencyCodeMDA, false},
		{CurrencyCodeMEC, false},
		{CurrencyCodeMED, false},
		{CurrencyCodeMEME, false},
		{CurrencyCodeMER, false},
		{CurrencyCodeMGC, false},
		{CurrencyCodeMGO, false},
		{CurrencyCodeMINEX, false},
		{CurrencyCodeMINT, false},
		{CurrencyCodeMITH, false},
		{CurrencyCodeMKR, false},
		{CurrencyCodeMLN, false},
		{CurrencyCodeMNE, false},
		{CurrencyCodeMNX, false},
		{CurrencyCodeMOD, false},
		{CurrencyCodeMONA, false},
		{CurrencyCodeMRT, false},
		{CurrencyCodeMSP, false},
		{CurrencyCodeMTH, false},
		{CurrencyCodeMTN, false},
		{CurrencyCodeMUE, false},
		{CurrencyCodeMUSIC, false},
		{CurrencyCodeMYB, false},
		{CurrencyCodeMYST, false},
		{CurrencyCodeMZC, false},
		{CurrencyCodeNAMO, false},
		{CurrencyCodeNANO, false},
		{CurrencyCodeNAS, false},
		{CurrencyCodeNAV, false},
		{CurrencyCodeNBT, false},
		{CurrencyCodeNCASH, false},
		{CurrencyCodeNDC, false},
		{CurrencyCodeNEBL, false},
		{CurrencyCodeNEO, false},
		{CurrencyCodeNEOS, false},
		{CurrencyCodeNET, false},
		{CurrencyCodeNLC2, false},
		{CurrencyCodeNLG, false},
		{CurrencyCodeNMC, false},
		{CurrencyCodeNMR, false},
		{CurrencyCodeNOBL, false},
		{CurrencyCodeNOTE, false},
		{CurrencyCodeNPXS, false},
		{CurrencyCodeNSR, false},
		{CurrencyCodeNTO, false},
		{CurrencyCodeNULS, false},
		{CurrencyCodeNVC, false},
		{CurrencyCodeNXC, false},
		{CurrencyCodeNXS, false},
		{CurrencyCodeNXT, false},
		{CurrencyCodeOAX, false},
		{CurrencyCodeOBITS, false},
		{CurrencyCodeOCL, false},
		{CurrencyCodeOCN, false},
		{CurrencyCodeODEM, false},
		{CurrencyCodeODN, false},
		{CurrencyCodeOF, false},
		{CurrencyCodeOK, false},
		{CurrencyCodeOMG, false},
		{CurrencyCodeOMNI, false},
		{CurrencyCodeONION, false},
		{CurrencyCodeONT, false},
		{CurrencyCodeOPT, false},
		{CurrencyCodeOST, false},
		{CurrencyCodePART, false},
		{CurrencyCodePASC, false},
		{CurrencyCodePAY, false},
		{CurrencyCodePBL, false},
		{CurrencyCodePBT, false},
		{CurrencyCodePFR, false},
		{CurrencyCodePING, false},
		{CurrencyCodePINK, false},
		{CurrencyCodePIVX, false},
		{CurrencyCodePIX, false},
		{CurrencyCodePLBT, false},
		{CurrencyCodePLR, false},
		{CurrencyCodePLU, false},
		{CurrencyCodePOA, false},
		{CurrencyCodePOE, false},
		{CurrencyCodePOLY, false},
		{CurrencyCodePOSW, false},
		{CurrencyCodePOT, false},
		{CurrencyCodePOWR, false},
		{CurrencyCodePPC, false},
		{CurrencyCodePPT, false},
		{CurrencyCodePPY, false},
		{CurrencyCodePRG, false},
		{CurrencyCodePRL, false},
		{CurrencyCodePRO, false},
		{CurrencyCodePST, false},
		{CurrencyCodePTC, false},
		{CurrencyCodePTOY, false},
		{CurrencyCodePURA, false},
		{CurrencyCodeQASH, false},
		{CurrencyCodeQAU, false},
		{CurrencyCodeQLC, false},
		{CurrencyCodeQRK, false},
		{CurrencyCodeQRL, false},
		{CurrencyCodeQSP, false},
		{CurrencyCodeQTL, false},
		{CurrencyCodeQTUM, false},
		{CurrencyCodeQWARK, false},
		{CurrencyCodeR, false},
		{CurrencyCodeRADS, false},
		{CurrencyCodeRAIN, false},
		{CurrencyCodeRBIES, false},
		{CurrencyCodeRBX, false},
		{CurrencyCodeRBY, false},
		{CurrencyCodeRCN, false},
		{CurrencyCodeRDD, false},
		{CurrencyCodeRDN, false},
		{CurrencyCodeREC, false},
		{CurrencyCodeRED, false},
		{CurrencyCodeREP, false},
		{CurrencyCodeREQ, false},
		{CurrencyCodeRHOC, false},
		{CurrencyCodeRIC, false},
		{CurrencyCodeRISE, false},
		{CurrencyCodeRLC, false},
		{CurrencyCodeRLT, false},
		{CurrencyCodeRPX, false},
		{CurrencyCodeRRT, false},
		{CurrencyCodeRUFF, false},
		{CurrencyCodeRUP, false},
		{CurrencyCodeRVT, false},
		{CurrencyCodeSAFEX, false},
		{CurrencyCodeSALT, false},
		{CurrencyCodeSAN, false},
		{CurrencyCodeSBTC, false},
		{CurrencyCodeSC, false},
		{CurrencyCodeSEELE, false},
		{CurrencyCodeSEQ, false},
		{CurrencyCodeSHIFT, false},
		{CurrencyCodeSIB, false},
		{CurrencyCodeSIGMA, false},
		{CurrencyCodeSIGT, false},
		{CurrencyCodeSJCX, false},
		{CurrencyCodeSKIN, false},
		{CurrencyCodeSKY, false},
		{CurrencyCodeSLR, false},
		{CurrencyCodeSLS, false},
		{CurrencyCodeSMART, false},
		{CurrencyCodeSMT, false},
		{CurrencyCodeSNC, false},
		{CurrencyCodeSNGLS, false},
		{CurrencyCodeSNM, false},
		{CurrencyCodeSNRG, false},
		{CurrencyCodeSNT, false},
		{CurrencyCodeSOC, false},
		{CurrencyCodeSOUL, false},
		{CurrencyCodeSPANK, false},
		{CurrencyCodeSPC, false},
		{CurrencyCodeSPHR, false},
		{CurrencyCodeSPR, false},
		{CurrencyCodeSNX, false},
		{CurrencyCodeSRN, false},
		{CurrencyCodeSTART, false},
		{CurrencyCodeSTEEM, false},
		{CurrencyCodeSTK, false},
		{CurrencyCodeSTORJ, false},
		{CurrencyCodeSTORM, false},
		{CurrencyCodeSTQ, false},
		{CurrencyCodeSTRAT, false},
		{CurrencyCodeSTX, false},
		{CurrencyCodeSUB, false},
		{CurrencyCodeSWFTC, false},
		{CurrencyCodeSWIFT, false},
		{CurrencyCodeSWT, false},
		{CurrencyCodeSYNX, false},
		{CurrencyCodeSYS, false},
		{CurrencyCodeTAAS, false},
		{CurrencyCodeTAU, false},
		{CurrencyCodeTCC, false},
		{CurrencyCodeTFL, false},
		{CurrencyCodeTHC, false},
		{CurrencyCodeTHETA, false},
		{CurrencyCodeTIME, false},
		{CurrencyCodeTIX, false},
		{CurrencyCodeTKN, false},
		{CurrencyCodeTKR, false},
		{CurrencyCodeTKS, false},
		{CurrencyCodeTNB, false},
		{CurrencyCodeTNT, false},
		{CurrencyCodeTOA, false},
		{CurrencyCodeTRAC, false},
		{CurrencyCodeTRC, false},
		{CurrencyCodeTRCT, false},
		{CurrencyCodeTRIG, false},
		{CurrencyCodeTRST, false},
		{CurrencyCodeTRUE, false},
		{CurrencyCodeTRUST, false},
		{CurrencyCodeTRX, false},
		{CurrencyCodeTUSD, false},
		{CurrencyCodeTX, false},
		{CurrencyCodeUBQ, false},
		{CurrencyCodeUKG, false},
		{CurrencyCodeULA, false},
		{CurrencyCodeUNB, false},
		{CurrencyCodeUNITY, false},
		{CurrencyCodeUNO, false},
		{CurrencyCodeUNY, false},
		{CurrencyCodeUP, false},
		{CurrencyCodeURO, false},
		{CurrencyCodeUSDT, false},
		{CurrencyCodeUTK, false},
		{CurrencyCodeVEE, false},
		{CurrencyCodeVEN, false},
		{CurrencyCodeVERI, false},
		{CurrencyCodeVIA, false},
		{CurrencyCodeVIB, false},
		{CurrencyCodeVIBE, false},
		{CurrencyCodeVIVO, false},
		{CurrencyCodeVOISE, false},
		{CurrencyCodeVOX, false},
		{CurrencyCodeVPN, false},
		{CurrencyCodeVRC, false},
		{CurrencyCodeVRM, false},
		{CurrencyCodeVRS, false},
		{CurrencyCodeVSL, false},
		{CurrencyCodeVTC, false},
		{CurrencyCodeVTR, false},
		{CurrencyCodeWABI, false},
		{CurrencyCodeWAN, false},
		{CurrencyCodeWAVES, false},
		{CurrencyCodeWAX, false},
		{CurrencyCodeWCT, false},
		{CurrencyCodeWDC, false},
		{CurrencyCodeWGO, false},
		{CurrencyCodeWGR, false},
		{CurrencyCodeWINGS, false},
		{CurrencyCodeWPR, false},
		{CurrencyCodeWTC, false},
		{CurrencyCodeWTT, false},
		{CurrencyCodeXAS, false},
		{CurrencyCodeXAUR, false},
		{CurrencyCodeXBC, false},
		{CurrencyCodeXBY, false},
		{CurrencyCodeXCN, false},
		{CurrencyCodeXCP, false},
		{CurrencyCodeXDN, false},
		{CurrencyCodeXEL, false},
		{CurrencyCodeXEM, false},
		{CurrencyCodeXHV, false},
		{CurrencyCodeXID, false},
		{CurrencyCodeXLM, false},
		{CurrencyCodeXMG, false},
		{CurrencyCodeXMR, false},
		{CurrencyCodeXMT, false},
		{CurrencyCodeXMY, false},
		{CurrencyCodeXPM, false},
		{CurrencyCodeXRL, false},
		{CurrencyCodeXRP, false},
		{CurrencyCodeXSPEC, false},
		{CurrencyCodeXST, false},
		{CurrencyCodeXTZ, false},
		{CurrencyCodeXUC, false},
		{CurrencyCodeXVC, false},
		{CurrencyCodeXVG, false},
		{CurrencyCodeXWC, false},
		{CurrencyCodeXZC, false},
		{CurrencyCodeXZR, false},
		{CurrencyCodeYEE, false},
		{CurrencyCodeYOYOW, false},
		{CurrencyCodeZCC, false},
		{CurrencyCodeZCL, false},
		{CurrencyCodeZCO, false},
		{CurrencyCodeZEC, false},
		{CurrencyCodeZEN, false},
		{CurrencyCodeZET, false},
		{CurrencyCodeZIL, false},
		{CurrencyCodeZLA, false},
		{CurrencyCodeZRX, false},
	}
	for _, tt := range tests {
		t.Run(tt.c.String(), func(t *testing.T) {
			if got := tt.c.IsPhysical(); got != tt.want {
				t.Errorf("CurrencyCode.IsPhysical() = %v, want %v", got, tt.want)
			}
		})
	}
}
